<script lang="ts">
import Vue from 'vue';
import { init, refresh } from 'aos';
import { NextStep, SlpContainer } from '../components/common/index';
import {
  QuotesCarousel,
  CustomerLogos,
  DevOpsLifeCycle,
  ResourceCards,
  Hero,
  SolutionsContainer as Solutions,
  SolutionsHeader as SolutionsContainer,
} from '../components/home/index';
import { getPageMetadata } from '../common/meta';

export default Vue.extend({
  components: {
    Hero,
    QuotesCarousel,
    CustomerLogos,
    DevOpsLifeCycle,
    ResourceCards,
    NextStep,
    SlpContainer,
    Solutions,
    SolutionsContainer,
  },
  async asyncData({ $content, params }: any) {
    const doc = await $content('index', params.slug).fetch();
    return { doc };
  },
  head() {
    return {
      ...getPageMetadata(this.doc, this.$route.fullPath),
      link: [
        {
          rel: 'alternate',
          hreflang: 'x-default',
          href: 'https://about.gitlab.com/',
        },
        {
          rel: 'alternate',
          hreflang: 'ja-jp',
          href: 'https://about.gitlab.com/ja-jp/',
        },
        {
          rel: 'alternate',
          hreflang: 'fr-fr',
          href: 'https://about.gitlab.com/fr-fr/',
        },
        {
          rel: 'alternate',
          hreflang: 'fr',
          href: 'https://about.gitlab.com/fr-fr/',
        },
        {
          rel: 'alternate',
          hreflang: 'de-de',
          href: 'https://about.gitlab.com/de-de/',
        },
        {
          rel: 'alternate',
          hreflang: 'de',
          href: 'https://about.gitlab.com/de-de/',
        },
      ],
    };
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  mounted() {
    this.onResize();
    window.addEventListener('resize', this.onResize);
    refresh();
  },
  destroyed() {
    window.removeEventListener('resize', this.onResize);
  },
  methods: {
    onResize() {
      this.width = window.innerWidth;
    },
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <Hero :data="doc.cta_block" />
      <CustomerLogos :data="doc.customer_logos_block" />
    </SlpContainer>
    <section>
      <DevOpsLifeCycle :data="doc.devops_lifecycle" />
    </section>
    <section>
      <SolutionsContainer :data="doc.solutions_block" />
    </section>
    <section>
      <Solutions :data="doc.solutions_block" />
    </section>
    <SlpContainer>
      <QuotesCarousel :data="doc.quotes_carousel_block" />
    </SlpContainer>
    <section>
      <ResourceCards :data="doc.resource_card_block" />
    </section>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>
